OSPy Sensors ESP32 by www.pihrt.com and ESP8266 (by Sonoff THxx) Readme 
====

## More information visit
[pihrt.com Martin Pihrt website](https://pihrt.com/) and [Arduino core for the ESP32 website](https://github.com/espressif/arduino-esp32)

INSTALLATION:
===========

### Arduino IDE in operating system (Linux or Windows)
- Install the current upstream Arduino IDE at the 1.8 level or later. The current version is at the [Arduino website](http://www.arduino.cc/en/main/software).
- Start Arduino and open Preferences window.
- Enter one of the release links above into *Additional Board Manager URLs* field. You can add multiple URLs, separating them with commas.
- ESP32 *URLs for Additional Board Manager* https://raw.githubusercontent.com/espressif/arduino-esp32/gh-pages/package_esp32_index.json
- ESP8266 *URLs for Additional Board Manager* https://arduino.esp8266.com/stable/package_esp8266com_index.json
- For ESP32 Open Boards Manager from Tools > Board menu and install *esp32* platform (and don't forget to select your ESP32 board from Tools > Board menu after installation).
- For ESP8266 Open Boards Manager from Tools > Board menu and install *esp8266* platform (and don't forget to select your ESP8266 board from Tools > Board menu after installation).
- Extract the OneWire and Dallas Temperature folders from the esp32/library folder. Then copy the folders to your arduino library location. Example: documents/arduino/libraries
- More infos with images is here: https://pihrt.com/elektronika/444-esp32-multisnimac-pro-opensprinkler-system and https://pihrt.com/elektronika/439-ospy-jak-pridat-a-pripojit-snimace

### ESP32 Flash Download Tool
The ability to upload an already compiled file to the processor without using Arduino.
To proceed, download the flash tool from here: https://www.espressif.com/en/support/download/other-tools
The ESP32 Flash Download Tool is the official Espressif Download tool that runs on Windows platform. The tool can be used to modify and generate init BINs, generate consolidated BIN files or program multiple chips for production runs. The tool uses COM port to send BIN files from PC to the ESP32, which then flashes the data to the primary flash chip.
There are multiple approaches to flashing the BIN files on to your ESP32 based system. Perhaps the simplest method to use with Espressif ESP32 ESP-IDF is to use command
"make flash" in the Linux environment instead of just "make". Make flash will invoke scripts to actually flash your BIN files to your ESP32 through the USB-to-UART adapter. However, this may not work very well if you are running the Linux environment on a Virtual Machine. In that case, the flash download tool comes in handy! However, here we will go through the process of programming the ESP32 with the GUI based ESP32 Flash Download Tool. It is the official tool from Espressif Systems, the manufacturer of ESP32. Or we don't want (we don't know how) to use Arduino for compilation. 

#### Setup
Select a particular tab to find related options. Select HSPI tab for HSPI flash download. In general, you should use SPI download mode. BIN files to be downloaded. The checkbox must be checked and the file and address must be valid for a file to be successfully opened by program for download. Crystal Frequency should be the frequency of the crystal connected to your ESP32 module. SPI Flash speed. You may switch to 80MHz with fast flash chips. However, the ESP-IDF v.1.0 seems to be having issues with this higher than 40MHz. Tells about the current operation status. Whether the download tool is idle or running, etc. Start/Stop button to start or stop programming. Progressbar to indicate firmware download program. COM port settings such as baud rate and port number. PHY MAC IDs for Wifi, BLE, ethernet, etc. Information on the flash chip. This is acquired by low level API and this information is necessary for evaluating flash map, etc at runtime. Flash memory size. Most modules will contain the ESP32 hooked to a Winbond 32MBit flash memory. You may change accordingly if your hardware differs.

#### Binary Download Locations
As in ESP32 ESP-IDF v.1.0 with no modified ld script files, the locations should be as follows for normal applications:
0x1000: bootloader.bin
0x4000: partitions_singleapp.bin
0x10000: .bin
The flash map is very simple as the ESP-IDF does not support OTA in this version yet. Therefore, the system only consists of a bootloader, a data partition table and the main user application BIN (generated by you by compiling your code).

#### Downloading the Program
Pull GPIO0 LOW by pressing the “program” button on your development board. Reset the ESP32 by pressing the EN button momentarily while holding down the IO0 button. Now the ESP32 will successfully enter the flash programming mode. You can now set the files and check the required BIN file slots in the software such that they are all set to be downloaded into the flash. Next press the Start button to continue and flash the BIN files into your ESP32 module! Make sure that the COM port has been correctly selected. The download tool would typically automatically detect an USB-UART converter.

#### Repeated Downloading (prototyping)
If you are repeatedly flashing revised versions of your application during the development process, note that you need not flash bootloader and singleapp partition BINs repeatedly. You simply need to flash the .bin every time you update your program and generate an updated BIN file. Uncheck the bootloader and partition BINs to prevent unnecessary writes to the flash.

## Acknowledgements
* Arduino IDE software https://arduino.cc.
* Arduino core for the ESP32 website https://github.com/espressif/arduino-esp32.
* Arduino core for the ESP8266 website https://github.com/esp8266/Arduino.
* DS18B20 libraries https://www.arduinolibraries.info/libraries/dallas-temperature.
* OneWire libraries https://www.arduinolibraries.info/libraries/one-wire.
* Adafruit DHT libraries https://github.com/adafruit/DHT-sensor-library.
* SparkFun HTU21 libraries https://github.com/sparkfun/SparkFun_HTU21D_Breakout_Arduino_Library.
* ADS1X15 libraries https://github.com/RobTillaart/ADS1X15.


Sensor ESP8266 FW Changelog
====

FW: 1.01
-----------
(martinpihrt)<br/>
Changes:<br/>
Working on it.


Sensor ESP32 FW Changelog
====

FW: 1.19
-----------
(martinpihrt)<br/>
Changes:<br/>
Added support for multi contact input (the multi sensor will act as a 7 button controller).

FW: 1.18
-----------
(martinpihrt)<br/>
Changes:<br/>
Added support for new hardware board HW:1.1 (multisensor by pihrt.com). New feture: two buttons for manual control for two relay. 2x LED for relays ON state. 1x LED for 3,3V power supply status. Contolling two relay via web server (from OSPy) instead one relay. Fixed: random clickering in relay (resistor in gate for FET 2N7002). Inductor package size on PCB. If GPIO4 and GPIO15 have pull-up resistors (state on GPIOs is on VCC 3,3V) then automatic detect and switch HW version to "1" HW1.1.<br/>
Added I2C (0x3c) OLED display 0,96" 128x64 (SSD1306) to display measured values from all inputs except humidity (DHTxx) and ultrasound (because these are on the I2C connector and cannot be used at the same time as the display).<br/>
New parameters for web:  
Example for on relay 1 to 400 second:  
http://192.168.88.207/0123456789abcdef?re=1&run=400  
For on relay 2 to 10 second:  
http://192.168.88.207/0123456789abcdef?re_2=1&run_r2=10  

FW: 1.17
-----------
(martinpihrt)<br/>
Changes:<br/>
Fixed bug in sensor "soil moisture". Tested with one ADS1115 converter (4 probes).

FW: 1.16
-----------
(martinpihrt)<br/>
Changes:<br/>
Fixed bug in sensor "motion" and "dry-contact" (send state after power on if input has not changed).

FW: 1.15
-----------
(martinpihrt)<br/>
Changes:<br/>
Added support for 16 pcs soil moisture (4x ADS1115) on I2C bus address: 0x48,0x49,0x4A,0x4B. To connect 16 pcs of humidity probes, it is necessary to connect 4 pcs of the ADS1115 circuit to the IIC bus to the multisensor board (1 pc always for 4 A/D inputs). Each ADS1115 circuit has its own IIC address set. Added support serial line (processing a request from a serial line) for example: AP| for starting AP manager. RBT| for rebooting.

FW: 1.14
-----------
(martinpihrt)<br/>
Changes:<br/>
AP manager - time for invocation: the time for calling up the AP manager with the button was increased to 4 seconds (at a time of 2 seconds, when manually controlling the relay with the button, the AP manager was called up by mistake, even if the user did not want it).

FW: 1.13
-----------
(martinpihrt)<br/>
Changes:<br/>
Fixed: value refresh for calibration of temperature sensors DS1-DS4. Removal of the hw timer for LED flashing and replacement by flashing in the loop.

FW: 1.12
-----------
(martinpihrt)<br/>
Changes:<br/>
Possibility of tuning (calibration of temperature sensors +- C) DS1-DS4 in menu AP manager.

FW: 1.11
-----------
(martinpihrt)<br/>
Changes:<br/>
Fix in ultrasonic probe.

FW: 1.10
-----------
(martinpihrt)<br/>
Changes:<br/>
Added function to webserver for starting AP manager from OSPy.

FW: 1.09
-----------
(martinpihrt)<br/>
Changes:<br/>
Added fake test for DS1-DS4 DS18B20 sensors (China clone sensors).

FW: 1.08
-----------
(martinpihrt)<br/>
Changes:<br/>
Added flash state to LED when the sensor is connecting to a Wi-Fi network. Added if the sensor is disconnected from Wi-Fi, the sensor will restart immediately. Added new parameter running time for relay outputs (ex: http://192.168.88.207/0123456789abcdef?re=1&run=120 re=1 is relay on and run=xxx is time in seconds 0123456789abcdff is secure code from sensor. If the run parameter is not specified, it will be ignored).

FW: 1.07
-----------
(martinpihrt)<br/>
Changes:<br/>
Fix time for AP manager to 10 minutes. Fix message in serial print. Add calibration for voltage divider in to AP settings. Divider correction (+-) = if we need to fine-tune the exact value of the voltage measurement 0-30V, then we can use the + - value for this adjustment. Example: the displayed voltage value is 10.7V and the actual value should be 12.7V (measured by a voltmeter on the main power input). Enter the value 20 in the field. The entered value is multiplied by the number 0.1 during the calculation. Add LED ON if relay is ON. Add ultrasonic support for distance level (not tested yet). Tested probe DHT22 and DHT11 for moisture measuring.

FW: 1.06
-----------
(martinpihrt)<br/>
Changes:<br/>
Add time limit for sending data (if it was not sent to the OSPy within 2 minutes, then restart the sensor). Sensor freeze prevention. 

FW: 1.05
-----------
(martinpihrt)<br/>
Changes:<br/>
Add selector for moisture probe type - user changeable (in AP mode). 
Add password for access to upload new firmware via http in STA (normal) mode - user changeable. For uploading in STA mode use html post "/FW_YOURUPLOADPASSWORD".
Add password for Wi-Fi access - user changeable (in AP mode).
Add moisture sensors DHT22 (AM2302, AM2321), DHT 21 (AM2301), DHT11 - used SDA pin GPIO33 (not used I2C bus).
Add moisture sensor SHT21 (HTU21D) used I2C bus.

FW: 1.04
-----------
(martinpihrt)<br/>
Changes:<br/>
Add leak detector to input via interrupt routine. If leak pulses > 0 sending http data in cycle 3 seconds (normal is 30 seconds). Add I2C scanner routine for find I2C addreses (for moisture and more sensors)

FW: 1.03
-----------
(martinpihrt)<br/>
Changes:<br/>
Add upload new firmware via web. Dry contact and motion now support pull-up or pull-down connection. Add manual relay on/off with AP button (if press time < 2 sec). Voltage check with R1=100K and R2=10K as divider from source to analog pin ESP32. Add CSS style (OpenSprinkler design). Add print time to reboot on pages. Fix read temperature 85C from 4x DS18B20.
 
FW: 1.02
-----------
(martinpihrt)<br/>
Changes:<br/>
Add AP manager for settings sensor from phone, tablet (4 minutes timeout). For run AP manager: push button least > 2 seconds. Password for AP Wi-Fi is "ospy-sensor-esp32", next open browser and type IP "192.168.1.1".<br/>
Add saving to eeprom memory. Fast blinking LED if AP manager. Slow blinking LED if normal run.<br/>
Add control relay from stations: ex: http://IP/securecode?re=1 (or re=0). In AP manager is active button  for control relay ON or OFF. Available only on the same network as OSPy.

FW: 1.01
-----------
(martinpihrt)<br/>
Changes:<br/>
Initial sensor version without AP manager.


